<?php
/*
 * Application :GladeXT for Php 
 */

$software_name          = 'Glade Sourcefile Maker';
$software_version       = '0.1';
$software_release_name  = $software_name.' '.$software_version;

error_reporting(E_ALL);


/*
 * Debuging : set parameter to TRUE or FALSE
 */
$_debug = TRUE;

/*
 * Loading PHP-GTK extension
 */
if (!class_exists('gtk')) 
{
    if (strtoupper(substr(PHP_OS, 0, 3)) == 'WIN')
    {
        dl('php_gtk.dll');
        $_INI['os']           = 'win';
        $_INI['new_line']     = "\r\n";
        $_INI['folder_sep']   = '\\';         
    }
    else
    {
        dl('php_gtk.so');
        $_INI['os']           = 'lin';
        $_INI['new_line']     = "\n";
        $_INI['folder_sep']   = '/';         
    }
}
else die ('impossible to load PHP-GTK extension');


include_once('gladeXT.func.php');

/*
 *
 *
 *
 */
function on_button_start_clicked( $button )
{
    $_debug     = &$GLOBALS['_debug'];
    $capture_to = &$GLOBALS['capture_to'];
    $captures   = &$GLOBALS['captures'];
    $trigger    = &$GLOBALS['trigger'];
    $handlers   = &$GLOBALS['handlers'];
    $handler_p  = &$GLOBALS['handler_p'];
    $user_change= &$GLOBALS['user_change'];
    $windows    = &$GLOBALS['windows'];
    
    $_INI       = &$GLOBALS['_INI'];
    
    if(FALSE != $_debug)
        echo "signal clicked called on_button_start_clicked. function is line ".__LINE__."\n";
        
    $req = get_form('glade_app_writer');
    $src_path      = $req['entry_glade_file'];
    $output_folder = $req['entry_output_path'];
    
    /*
     *
     * user input parameters
     */
    
    // glade file : path to glade file. absolute or relative, no matter
    //$src_path    = './gladeXT.glade';
    
    // output path is a folder NO ending slash
    // notice : {auto} will create a folder with app name and use it for copying files
    //$output_folder = '{auto}';
    
    
    /*
     * setting file to save to
     */
    
    //we extract folder name and filename
    $src_path       = realpath($src_path);  // should work because file exist
    $src_file       = basename($src_path);        
    $input_folder   = dirname($src_path).$_INI['folder_sep'];
    //$output_folder  = dirname($output_folder).$_INI[folder_sep];
    
    // getting app name from glade filename
    $parts = explode('.',$src_file);
    // we take off .glade
    $last = count($parts)-1;
    if ('glade' == $parts[$last])
        unset($parts[$last]);
    $appname = implode('.',$parts);
    
    // setting main file name
    $savein = $appname.'.app.php';
    
    // looking for a {glade}.func.php file that could be included
    if (FALSE != is_file($appname.'.func.php'))
        $includes[] = $appname.'.func.php';
      
    if (FALSE != is_file($appname.'.inc.php'))
        $includes[] = $appname.'.inc.php';
    
    if (FALSE != is_file($appname.'.lib.php'))
        $includes[] = $appname.'.lib.php';  
    
    // to prevent error at end of script
    if (FALSE == is_array($includes)) 
        $includes = array();  
    
    
    echo "PHP application writer for Glade\n";
    echo "\twritten by : Jean Philippe Giot, august 2002.\n";
    echo "\tlicense    : GNU GPL\n";
    echo "\tversion    : 0.1\n";
    echo "Start Parameters\n";
    echo "\tgiven input  : $src_path\n";
    echo "\tinput folder : $input_folder \n";
    echo "\toutput folder: $output_folder\n";
    
    
    echo "starting parsing glade xml...\n";
    
    
    $xml_parser = xml_parser_create();
    xml_set_element_handler($xml_parser, "startElement", "endElement");
    xml_set_character_data_handler($xml_parser, "characterData");
    
    // opening glade file and storing pointer in $fp
    $fp = @fopen($src_path, "r");
    if (FALSE == $fp) 
        die("could not open XML input : file $src_path\n");
    
    // readding and parsing file
    while ($data = fread($fp, 4096)) 
    {
        if (!xml_parse($xml_parser, $data, feof($fp))) 
            die(sprintf("XML error: %s at line %d\n",xml_error_string(xml_get_error_code($xml_parser)),xml_get_current_line_number($xml_parser)));
    }
    
    // freeing ressources
    xml_parser_free($xml_parser); 
    @fclose($fp);

    
    echo "...done.\n";
    
    echo "== PARSING RESULTS ==\n";
    echo "project name   : $captures[project_name]\n";
    echo "windows count  : ".count($windows)."\n";
    echo "handlers count : ".count($handlers)." handlers found\n";
    echo "== end ==\n";
    
    // creating folder if $output_folder == '{auto}';
    if ('{auto}' == $output_folder)
    {
        $oldumask = umask(0);
        // destination folder
        $output_folder = $input_folder.$_INI['folder_sep'].$captures['project_name'].$_INI['folder_sep'];
        if (FALSE == is_dir($output_folder))
        {
            if (FALSE == mkdir($output_folder, 0775))
                die ('impossible to create destination folder '.$output_folder."!\n");
            umask($oldumask);
        }
        else echo "folder $output_folder already exists\n";
    }
    
    
    
    /*
     * Writing application
     */
    
    echo "Writing Php Application...\n";
    
    if (!($fdest = fopen($output_folder.$savein, "w"))) 
    {
       die("could not open destination file!\n");
    }
    
    
    // writing header
    fwrite ($fdest,'<?php'."\n");
    
    // writing a comment about application
    fwrite ($fdest,"/*\n");
    fwrite ($fdest," * Application : $captures[project_name] \n");
    fwrite ($fdest," *\n");
    fwrite ($fdest," * creator     : \n");
    fwrite ($fdest," * created on  : ".date('Y-m-d')."\n");
    fwrite ($fdest," * version     : \n");  
    fwrite ($fdest," * license     : \n");    
    fwrite ($fdest," *\n");
    fwrite ($fdest," * created with: ".$GLOBALS['software_release_name']."\n");
    fwrite ($fdest," *             : http://membres.lycos.fr/tutmedcaen/gladeXT/\n");
    fwrite ($fdest," */\n\n");
    
    // debuging
    fwrite ($fdest,"/*\n");
    fwrite ($fdest," * Debuging : set parameter to TRUE or FALSE\n");
    fwrite ($fdest," */\n\$_debug = TRUE;\n\n");
    
    // debuging
    fwrite ($fdest,"/*\n");
    fwrite ($fdest," * Error reporting. \n");
    fwrite ($fdest," *   Remeber to turn it on while developping,\n");
    fwrite ($fdest," *   it can avoid you to waste time and security holes\n");    
    fwrite ($fdest," */\n//error_reporting('E_ALL');\n\n");    
    
    // loading php gtk 
    fwrite ($fdest,"/*\n");
    fwrite ($fdest," * Loading PHP-GTK extension\n");
    fwrite ($fdest," */\n");
    fwrite ($fdest,"if (!class_exists('gtk')) {\n");
    fwrite ($fdest,"\tif (strtoupper(substr(PHP_OS, 0, 3)) == 'WIN')\n");
    fwrite ($fdest,"\t{\n");
    fwrite ($fdest,"\t\tdl('php_gtk.dll');\n");
    fwrite ($fdest,"\t\t//\$_INI['os']\t= 'win';\n");
    fwrite ($fdest,"\t\t//\$_INI['new_line']\t= \"\\r\\n\";\n");
    fwrite ($fdest,"\t\t//\$_INI['folder_sep']\t= '\\';\n");    
    fwrite ($fdest,"\t}\n");    
    fwrite ($fdest,"\telse\n");
    fwrite ($fdest,"\t{\n");    
    fwrite ($fdest,"\t\tdl('php_gtk.so');\n");
    fwrite ($fdest,"\t\t//\$_INI['os']\t= 'lin';\n");
    fwrite ($fdest,"\t\t//\$_INI['new_line']\t= \"\\n\";\n");
    fwrite ($fdest,"\t\t//\$_INI['folder_sep']\t= '/';\n");    
    fwrite ($fdest,"\t}\n");    
    fwrite ($fdest,"}\n\n\n");
    
    // writing inclusions
    fwrite ($fdest,"/*\n");
    fwrite ($fdest," * Including files\n");
    fwrite ($fdest," */\n\n");
    foreach ($includes as $id => $filename)
    {
        fwrite ($fdest,"include('$filename');\n");
    }
    fwrite ($fdest,"\n\n");
    
    print_r($handlers);
    echo " counter : $handler_p\n";
    
    echo "Writing ".count($handlers)." signal functions\n";
    // writing all functions that are declared callbacks in glade file
    $parameters = '';
    fwrite ($fdest,"\n\n/************   GLADE application signal handlers **********************/\n\n");
    foreach ($handlers as $name => $handler_array)
    {
        echo " function : $handler_array[signal_handler]\n";
        switch ($handler_array['widget_class'])
        {
            case 'GtkButton': $parameters = ' $button '; break;
            default: break; 
        }
        fwrite ($fdest,"/*\n *\n *\n *\n */\nfunction $handler_array[signal_handler]($parameters)\n{\n");
        fwrite ($fdest,"\t\$_debug = &\$GLOBALS['_debug'];\n");
        fwrite ($fdest,"\tif(FALSE != \$_debug)\n");
        fwrite ($fdest,"\t\techo \"signal ".$handler_array['signal_name']." called $handler_array[signal_handler]. function is line \".__LINE__.\"\\n\";\n");
        fwrite ($fdest,"\t\n}\n\n");
        $parameters = '';
    }
    
    echo "writing extra functions\n";
    fwrite ($fdest,"\n\n/************   Extra Functions use them if you whish **********************/\n\n");
    
    // writing quit app function
    fwrite ($fdest,"/*\n *  Exit Application\n *\n *\n */\nfunction quit_app()\n{\n");
    fwrite ($fdest,"\t\$_debug    = &\$GLOBALS['_debug'];\n");
    fwrite ($fdest,"\t\n");    
    fwrite ($fdest,"\tif(FALSE != \$_debug)\n");
    fwrite ($fdest,"\t\techo \"Leaving. Bye\\n\";\n");
    fwrite ($fdest,"\t\n");    
    fwrite ($fdest,"\tGtk::main_quit();\n");
    fwrite ($fdest,"}\n\n");
    
    
    // writing show_window function
    fwrite ($fdest,"/*\n *  Show window given in parameter\n *\n *\n */\nfunction show_window(\$window_name)\n{\n");
    fwrite ($fdest,"\t\$_debug    = &\$GLOBALS['_debug'];\n");
    fwrite ($fdest,"\t\$glade_app = &\$GLOBALS['glade_app'];\n");
    fwrite ($fdest,"\t\n");    
    fwrite ($fdest,"\tif(FALSE != \$_debug)\n");
    fwrite ($fdest,"\t\techo \"showing window \$window_name\\n\";\n");
    fwrite ($fdest,"\t\$widget = \$glade_app->get_widget(\$window_name);\n");
    fwrite ($fdest,"\t\$widget->show();\n");
    fwrite ($fdest,"}\n\n");
    
    
    // writing hide_window function
    fwrite ($fdest,"/*\n *  Hide Window given in paramter\n *\n *\n */\nfunction hide_window(\$window_name)\n{\n");
    fwrite ($fdest,"\t\$_debug    = &\$GLOBALS['_debug'];\n");
    fwrite ($fdest,"\t\$glade_app = &\$GLOBALS['glade_app'];\n");    
    fwrite ($fdest,"\t\n");    
    fwrite ($fdest,"\tif(FALSE != \$_debug)\n");
    fwrite ($fdest,"\t\techo \"hiding window \$window_name\\n\";\n");
    fwrite ($fdest,"\t\$widget = \$glade_app->get_widget(\$window_name);\n");
    fwrite ($fdest,"\t\$widget->hide();\n");
    fwrite ($fdest,"}\n\n");
    
    
    // writing get_form function
    fwrite ($fdest,"/*\n *  Return an array containing as key all user input widget name\n *\n *\n */\nfunction get_form(\$window_name)\n{\n");
    fwrite ($fdest,"\t\$_debug    = &\$GLOBALS['_debug'];\n");
    fwrite ($fdest,"\t\$glade_app = &\$GLOBALS['glade_app'];\n");
    fwrite ($fdest,"\t\n");    
    fwrite ($fdest,"\tif(FALSE != \$_debug)\n");
    fwrite ($fdest,"\t\techo \"getting form values for \$window_name window\\n\";\n");
    fwrite ($fdest,"\t\n");
    
    fwrite ($fdest,"\tswitch (\$window_name)\n");
    fwrite ($fdest,"\t{\n");
    
    foreach ($windows as $windowid => $window_name)
    {
        fwrite ($fdest,"\t\tcase '$window_name':\n");
        fwrite ($fdest,"\t\t{\n");
        
        // this may trigger a notice while parsing if window
        // has no user editable widget. no matter
        $inputs = $user_change["$window_name"];
        
        if (FALSE != is_array($inputs))
        foreach ($inputs as $widget_type => $widget_list)
        {
            fwrite ($fdest,"\n\t\t\t/*\n");
            fwrite ($fdest,"\t\t\t * getting $widget_type\n");
            fwrite ($fdest,"\t\t\t */\n");
            if (FALSE != is_array($widget_list))
            foreach ($widget_list as $id => $input_name)
            {
                //fwrite ($fdest,"\t\t\t// $input_name\n");
                fwrite ($fdest,"\t\t\t\$widget = \$glade_app->get_widget('$input_name');\n");
                switch ($widget_type)
                {
                    case 'GtkEntry':
                    {
                        fwrite ($fdest,"\t\t\t\$ret['$input_name']\t = \$widget->get_text();\n");
                        break;
                    }
                    default:
                    {
                        break;
                    }
                }
                fwrite ($fdest,"\t\t\t\n");            
            }
        }
        fwrite ($fdest,"\t\t\tbreak;\n"); // end case window_name
        fwrite ($fdest,"\t\t}\n"); // end case window_name
    }
    // default for switch
    fwrite ($fdest,"\t\tdefault: break;\n");
    
    fwrite ($fdest,"\t}\n"); // end switch
    
    // writing return array value
    fwrite ($fdest,"\treturn \$ret;\n"); // end case window_name
    
    fwrite ($fdest,"}\n\n"); // end function
    
    
    /*
     * writing php code to parse glade application
     */
    
    fwrite ($fdest,"\$glade_app = &new GladeXML('$src_file');\n");
    fwrite ($fdest,"\$glade_app->signal_autoconnect();\n");
    fwrite ($fdest,"Gtk::main();\n?>");
    fclose ($fdest);
    echo "...done.\n";
    
    /*
     * Writing a batch file for windows
     */
    if ( 'win' == $_INI['os'] )
    {
        echo "Writing windows bat file...\n";
        if (!($fdest = fopen($output_folder.$savein.'.bat', "w"))) 
        {
            die("could not open destination file!\n");
        }
    
        fwrite ($fdest,'@echo off'.$_INI['new_line']);
        fwrite ($fdest,'cls'.$_INI['new_line']);
        fwrite ($fdest,'echo '.$captures['project_name'].$_INI['new_line']);
        fwrite ($fdest,'php.exe -q -e '.$savein.$_INI['new_line']);
        fwrite ($fdest,'pause');
    
        echo "...done.\n";
    
    }
    
    /*
     * Copying original glade file
     */
    echo "Copying glade source file and includes...\n";
    
    $includes[] = $src_file;
    
    foreach ($includes as $id => $filename)
    {
        echo '   from : '.$input_folder.$filename."\n";
        echo '   to   : '.$output_folder.$filename."\n";
        echo '    ->  : ';
        if (!@copy($input_folder.$filename, $output_folder.$filename)) 
           echo 'Error!';
        else
           echo 'Ok';
        echo "\n";
    }
    
    $return_from_main = TRUE;
    
    
    if (FALSE != $return_from_main)
    {
        show_window('window_project_saved');
    }
    else
    {
        show_window('window_error');
    }
}


/*
 *
 *
 *
 */
function on_glade_app_writer_destroy()
{
    quit_app();
}

/*
 *
 *
 *
 */
function on_button_saved_ok_clicked()
{
    hide_window('window_project_saved');
}

/*
 *
 *
 *
 */
function on_button_error_ok_clicked()
{
    hide_window('window_error');
}

/*
 *
 *
 *
 */
function on_window_error_destroy()
{
    hide_window('window_error');
}

/*
 *
 *
 *
 */
function on_window_project_saved_destroy()
{
    hide_window('window_project_saved');
}


/*
 *
 *
 *
 */
function on_about_menu_about_activate()
{
    show_window('window_about');
}


/*
 *
 *
 *
 */
function on_file_menu_quit_activate()
{
    quit_app();
}


/*
 *
 *
 *
 */
function on_button_close_clicked()
{
    hide_window('window_about');
}

/*
 *
 *
 *
 */
function on_window_about_destroy()
{
    hide_window('window_about');
}





/*
 *  Exit Application
 *
 *
 */
function quit_app()
{
    global $_debug;
    if(FALSE != $_debug)
        echo "Leaving. Bye\n";
    Gtk::main_quit();
}

/*
 *  show window given in parameter
 *
 *
 */
function show_window($window_name)
{
    global $_debug;
    global $glade_app;
    if(FALSE != $_debug)
        echo "showing window $window_name\n";
    $widget = $glade_app->get_widget($window_name);
    $widget->show();
}

/*
 *  Hide Window given in paramter
 *
 *
 */
function hide_window($window_name)
{
    global $_debug;
    global $glade_app;
    if(FALSE != $_debug)
        echo "hiding window $window_name\n";
    $widget = $glade_app->get_widget($window_name);
    $widget->hide();
}


/*
 *
 *
 *
 */
function get_form($window)
{
    global $glade_app;
    global $_debug;
    if(FALSE != $_debug)
        echo "getting form values for $window\n";
    
    switch ($window)
    {
        case 'glade_app_writer':
        {

            /*
             * getting GtkEntry
             */
            $widget = $glade_app->get_widget('entry_glade_file');
            $ret['entry_glade_file']   = $widget->get_text();
            
            $widget = $glade_app->get_widget('entry_output_path');
            $ret['entry_output_path']  = $widget->get_text();
            
            break;
        }
        case 'window_project_saved':
        {
            break;
        }
        case 'window_error':
        {
            break;
        }
        default: break;
    }
    return $ret;
}


function main()
{
    global $glade_app;
    // hiding two other windows
    hide_window('window_project_saved');
    hide_window('window_error');    
    hide_window('window_about');        
}

$glade_app = &new GladeXML('gladeXT.glade');
$glade_app->signal_autoconnect();
main();
Gtk::main();
?>