<?php
/*
 * initialisation of variables used in XML parser
 */
$capture_to = '';
$captures   = array
    (
        'project_name'      => '',
        'widget_name'       => '',
        'widget_class'      => '',
        'signal_name'       => '',
        'signal_handler'    => ''
    );
$handlers   = array();
$handler_p  = 0;
$user_change= array();
$windows    = array();
$trigger    = array
    (
        'name'                  => '',
        'on_close_save_signal'  => '',
        'register_user_input'   => '',
        'register_new_window'   => ''
    );



// XML parser functions
function startElement($parser, $tagname, $attrs) 
{
    $_debug     = &$GLOBALS['_debug'];
    $capture_to = &$GLOBALS['capture_to'];
    $captures   = &$GLOBALS['captures'];
    $trigger    = &$GLOBALS['trigger'];
    $handlers   = &$GLOBALS['handlers'];
    $handler_p  = &$GLOBALS['handler_p'];
    $user_change= &$GLOBALS['user_change'];
    $windows    = &$GLOBALS['windows'];

    $name = strtolower($tagname);
    
    // here we set where to store data next time characterData is called
    // and also what to trigger if another widget is found
    switch ($name)
    {
        case 'project' : 
        {
            // next name tag will be stored in 
            $trigger['name'] = 'project_name';
            // nothing to store now
            $capture_to = '';
            //echo "next time capturing project name\n";
            break;
        }
        
        case 'widget' : 
        {
            // next name tag will be stored in 
            $trigger['name'] = 'widget_name';
            // nothing to store
            $capture_to = '';
            // we delete old widget name
            $captures['widget_name']='';
            break;
        }
        
        case 'class':
        {
            $capture_to = 'widget_class';
            break;
        }        
        
        case 'signal':
        {
            // next name tag will be stored in 
            $trigger['name'] = 'signal_name';
            $trigger['on_close_save_signal'] = TRUE;
            // nothing to store
            $capture_to = '';            
            break;
        }        
        
        case 'handler':
        {
            $capture_to = 'signal_handler';
            break;
        }

        case 'name':
        {
            $capture_to = $trigger['name'];
            //echo "capturing name for $trigger[name]\n";
            break;
        }
        
        default:
        {
            $capture_to = '';
            break;
        }
    } // end switch       
}


function characterData($parser,$data)
{
    $_debug     = &$GLOBALS['_debug'];
    $capture_to = &$GLOBALS['capture_to'];
    $captures   = &$GLOBALS['captures'];
    $trigger    = &$GLOBALS['trigger'];
    $handlers   = &$GLOBALS['handlers'];
    $handler_p  = &$GLOBALS['handler_p'];
    $user_change= &$GLOBALS['user_change'];
    $windows    = &$GLOBALS['windows'];;
    
    // we capture data in $capture_to
    if( ('' != $capture_to) && (FALSE != $data) )
    {
        $text = trim($data);
        
        if ('' != $capture_to)
        {
            //echo "capturing => $capture_to\n";
            $captures["$capture_to"] = $text;
        }
        
        if (FALSE != $trigger['register_user_input'])
        {
            // we register user input if necessary
            
            if (FALSE != $captures['widget_name'])
            {
                echo 'adding '.$captures['widget_class'].' to '.$captures['window_name']." user editable list\n";
                $user_change[$captures['window_name']][$captures['widget_class']][] = $text;
                $trigger['register_user_input'] = '';
            }
            else echo "impossible to register user input, widget_name is missing\n";
        }
        
        if (FALSE != $trigger['register_new_window'])
        {
            // we register new windows in list
            echo "found new window : $text\n";
            $captures['window_name'] = $text;
            $windows[] = $text;
            $trigger['register_new_window']='';
        }        
        
        // then on new widgets, we should examine class datas which are widgets types
        if ('widget_class' == $capture_to)
        {
            //echo "cardata text : $text\n";
            switch ($text)
            {
                case 'GtkWindow':
                {
                    // this is the current window
                    // we save it's name next time a name is found
                    $trigger['register_new_window'] = TRUE;
                    $trigger['name'] = 'window_name';
                    break;
                }
                case 'GtkEntry':        // Jump
                case 'GtkRadioButton':  // Jump
                case 'GtkCheckButton':  // Jump
                {
                    // we save it in user input array next time
                    $trigger['register_user_input'] = TRUE;
                    break;
                }
                default:
                {
                    //echo "nothing to do special with $text widget\n";
                    break;
                }
            }
        }     
        
        // cleaning 
        $capture_to = '';
    }
}

function endElement($parser, $tagname) 
{
    $_debug     = &$GLOBALS['_debug'];
    $capture_to = &$GLOBALS['capture_to'];
    $captures   = &$GLOBALS['captures'];
    $trigger    = &$GLOBALS['trigger'];
    $handlers   = &$GLOBALS['handlers'];
    $handler_p  = &$GLOBALS['handler_p'];
    $user_change= &$GLOBALS['user_change'];
    $windows    = &$GLOBALS['windows'];    
    
    switch (strtolower($tagname))
    {
        case 'signal':
        {
            if ( (FALSE != $trigger['on_close_save_signal']) && (FALSE != $captures['signal_handler']) )
            {                
                $handlers[$handler_p]['widget_name']      = $captures['widget_name'];
                $handlers[$handler_p]['widget_class']     = $captures['widget_class'];
                $handlers[$handler_p]['signal_name']      = $captures['signal_name'];
                $handlers[$handler_p]['signal_handler']   = $captures['signal_handler'];
                $handler_p++;      
                
                if (FALSE != $_debug)
                {
                    echo "saving : $handler_p (window : ".$captures['window_name'].")\n";
                    echo "\tcurrent widget\t$captures[widget_name]\n";
                    echo "\twidget class\t$captures[widget_class]\n";
                    echo "\tsignal name\t$captures[signal_name]\n";
                    echo "\tsignal handler\t$captures[signal_handler]\n";
                    echo "\tcurrently ".count($handlers).' handlers found'."\n";
                    echo "\n";
                }

                // cleaning signal values
                $captures['signal_name']='';
                $captures['signal_handler']='';
            }
            break;
        }        
        default:
        {
            break;
        }
    }    
}